/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package symreader;
/*
 *
 * @author (c) Patrick Meng 2008
 */


class InstrMetaInfo{
    int R=255,G=255,B=255;
    float x,y,z;
    boolean MainLead = false;
    boolean Lead2 = false;
    boolean Background = false;
    boolean Percussion = false;
    boolean IsAFx = false;
    boolean Beat = false;
    boolean SubBeat = false;
    int Speed = 0; // 0 = slow, 10 = fast
    int Warmth = 0; // 10 = hot, -10 cold
    int Size = 0;       // 0 = tiny, 10 = huge
    int Synthethic = 0; // 0 = natural, 10 = very synthetic
    int purness = 0;
}

interface MultichannelType {
    int	Mono	=   0;
    int	StereoL	=   1;
    int	StereoR	=   2;
    int	Virtual	=   3;
}


class SymphonieInstrument {
    ImportSample ImportSample = new ImportSample();
    int ID; // Instr-Number in Song Events
    String Name = "unnamed";
    boolean isInUse = false;
    
    int Type;
    private int LoopStart= 0;
    private int Looplen = 0;
    private int LoopNumb = 0; // 0 = Endless Loop
    int MultiChannel = 0; // Mono, Stereo L, Stero R, VirtualMix
    boolean AutoMaximize;
    int Volume = 100;
    int Relation = 0;
    int NumbOfChildren = 0;
    int FineTune = 0;
    int Tune = 24;
    
    boolean PanningActive = false;
    float PanningX=0;  // -1000 = Left, 1000 = Right
    float PanningY=0;
    float PanningZ=0;
    
    boolean TwoWayLoop = false;
    
    int PlayFlag; // temp var for import
    boolean AllowPosDetune = true;   //SPLAYFLAG_DODETUNE 
    boolean PlaySynced = false;     //SPLAYFLAG_SUPERFAST
    boolean NoDsp = false;           //SPLAYFLAG_NODSP

    // LS FLAGS
    int LineSampleFlags = 0; // temp var for import
    boolean PlayReverse = false;         // BIT 0: reverse sample
    boolean AsQueue = false;             // BIT 1: interprete as list of samples (no mix) 
    boolean MirrorX = false;             // BIT 2;B: mirror x axis sample
    //boolean Resolution16Bit = false;     // BIT 3: for deltapack16
    int     SampleResolution = 8;
    boolean NewLoopSystem = false;       // BIT 4: New LoopSystem
    //boolean NoDsp2 = true;                // BIT 5: None Dsp    
    
    int SimpleLPFilter = 0;
    int NumbOfDownsample = 0;
    int Resonance = 0;
    // Sampledata
    boolean VirtualSample = false;
    boolean SampleDataLoaded = false;
    SamplePool sp; // 
    int SampleSourceType = 0; //0 = Raw, 1= Deltapacked, 2 = Deltapacked16Bit
    InstrMetaInfo MetaInfo = new InstrMetaInfo();
    private boolean hasALoop = false;                // True -> has a looping set
    
//    void setLoopStartPercent(int i) { // Old Format 100*256 = 100%, Only for Importing
//	LoopStart = i;
//    }
    void setLoopStart(int i) { // in Samples
	LoopStart = i;
    }
//    void setLoopLenPercent(int i) { // Old Format, Only for Importing
//	Looplen = i;
//    }
    void setLoopLen(int i) { // in Samples
	Looplen = i;
    }
    
    int getMaxLoopStart() { // in Samples
	return(sp.getNumbOfSamples()-1);
    }
    
    int getMaxLoopLen() { // in Samples
	return(sp.getNumbOfSamples() - sp.getLoopStart() - 2);
    }
    
    void verifyLoopStart() {
	if(getLoopStart() > getMaxLoopStart()) {
	    setLoopStart(getMaxLoopStart());
	}
    }
    
    void verifyLoopLen() {
	if(getLoopLen() > getMaxLoopLen()) {
	    setLoopLen(getMaxLoopLen());
	}
    }
    
    
    int getLoopStart() {return(LoopStart);} // in Samples
    int getLoopLen() {return(Looplen);} // in Samples
    
    boolean checkReady() {
        boolean ready = true;
        if(SampleDataLoaded == false ) ready = false;
        if(sp == null ) {
            ready = false;
        } else {
            if(sp.getNumbOfSamples() == 0) ready = false;
        }
        return(ready);
    }
    
    void deactivateLoop() {
        setNumbOfLoops(0); // 0 = Endless loop
        setHasLoop(false);
    }
    
    int getNumbOfLoops() {return(LoopNumb);} // 0 = no looping
    void setNumbOfLoops(int i) {LoopNumb=i;} // 0 = no looping
    boolean hasLoop() {return(hasALoop);}
    void setHasLoop(boolean mybool) {hasALoop = mybool;}
    
    
    void updateLoopParameters() { // Sync Loop to Samplepools
        sp.updateLoopStartAndLen(getLoopStart(), getLoopLen());
    }
    
    
}

    //LSFLAGS_RVS		EQU	0	;BIT 0: reverse sample
    //LSFLAGS_ASQUEUE		EQU	1	;BIT 1: interprete as list of samples (no mix)
    //LSFLAGS_MIRROR		EQU	2	;BIT 2;B: mirror x axis sample
    //LSFLAGS_16BIT		EQU	3	;BIT 3: for deltapack16
    //LSFLAGS_NEWLOOP		EQU	4	;New LoopSystem
    //LSFLAGS_NODSP		EQU	5	;None Dsp    

    
    
    
    /*

        


INSTRTYPE_SILENT	EQU	-8
INSTRTYPE_KILL	EQU	-4
INSTRTYPE_NONE	EQU	0
INSTRTYPE_LOOP	EQU	4
INSTRTYPE_SUST	EQU	8        

    
SAMPLENAME_INSTRTYPE	EQU	128	;0=No Instr
SAMPLENAME_LOOPSTART	EQU	129	;%
SAMPLENAME_LOOPLEN	EQU	130	;%
SAMPLENAME_LOOPNUMB	EQU	131	;0=ENDLESS, 1-255
SAMPLENAME_MULTI	EQU	132	;0=MONO
SAMPLENAME_AUTOMAXIMIZE	EQU	133	;0=NO, 1=YES
SAMPLENAME_VOLUME	EQU	134	;0=NO, VOLUME in %1...200%
SAMPLENAME_RELATION	EQU	135	;0=INDEPENDET, 1=PARENT 2=CHILD UNUSED
SAMPLENAME_CHILDNUMB	EQU	136	;0=INDEPENDET UNUSED
;SAMPLENAME_SAMPLETYPE	EQU	137	;0=RAW, 1=IFF
SAMPLENAME_FINETUNE	EQU	138	;SIGNED 0=None [-127...+127]
SAMPLENAME_TUNE		EQU	139	;SIGNED 0=None [-24...+24
SAMPLENAME_LSFLAGS	EQU	140	;LINESAMPLE FLAGS
SAMPLENAME_FILTER	EQU	141	;0=NONE
SAMPLENAME_PLAYFLAG	EQU	142	;0=NRM
SAMPLENAME_DOWNSAMPLE	EQU	143	;0=NONE
SAMPLENAME_RESO		EQU	144	;0=NONE
SAMPLENAME_LOADFLAGS	EQU	145	;0=NORMAL
SAMPLENAME_INFO		EQU	146	;BIT0 
SAMPLENAME_RANGEBGN	EQU	147	;%
SAMPLENAME_RANGELEN	EQU	148	;%
SAMPLENAME_LOOPSTARTLO	EQU	150	; lower bits of loop
SAMPLENAME_LOOPLENLO	EQU	152	; lower bits of loop

SAMPLENAME_RESOFILTERFLAGS EQU	160	;4x LP od HP
SAMPLENAME_RESOFILTERNUMB EQU	161	;Anzahl Punkte
SAMPLENAME_RESOFILTER	EQU	162	;bis 170

SAMPLENAME_VFADESTATUS	EQU	170
SAMPLENAME_VFADEBGN	EQU	SAMPLENAME_VFADESTATUS+1
SAMPLENAME_VFADEEND	EQU	SAMPLENAME_VFADEBGN+1    
*/  

/*
 * SAMPLENAME_INSTRTYPE	EQU	128	;0=No Instr
SAMPLENAME_LOOPSTART	EQU	129	;%
SAMPLENAME_LOOPLEN	EQU	130	;%
SAMPLENAME_LOOPNUMB	EQU	131	;0=ENDLESS, 1-255
SAMPLENAME_MULTI	EQU	132	;0=MONO
SAMPLENAME_AUTOMAXIMIZE	EQU	133	;0=NO, 1=YES
SAMPLENAME_VOLUME	EQU	134	;0=NO, VOLUME in %1...200%
SAMPLENAME_RELATION	EQU	135	;0=INDEPENDET, 1=PARENT 2=CHILD UNUSED
SAMPLENAME_CHILDNUMB	EQU	136	;0=INDEPENDET UNUSED
;SAMPLENAME_SAMPLETYPE	EQU	137	;0=RAW, 1=IFF
SAMPLENAME_FINETUNE	EQU	138	;SIGNED 0=None [-127...+127]
SAMPLENAME_TUNE		EQU	139	;SIGNED 0=None [-24...+24
SAMPLENAME_LSFLAGS	EQU	140	;LINESAMPLE FLAGS
SAMPLENAME_FILTER	EQU	141	;0=NONE
SAMPLENAME_PLAYFLAG	EQU	142	;0=NRM
SAMPLENAME_DOWNSAMPLE	EQU	143	;0=NONE
SAMPLENAME_RESO		EQU	144	;0=NONE
SAMPLENAME_LOADFLAGS	EQU	145	;0=NORMAL
SAMPLENAME_INFO		EQU	146	;BIT0 
SAMPLENAME_RANGEBGN	EQU	147	;%
SAMPLENAME_RANGELEN	EQU	148	;%
SAMPLENAME_LOOPSTARTLO	EQU	150	; lower bits of loop
SAMPLENAME_LOOPLENLO	EQU	152	; lower bits of loop

SAMPLENAME_RESOFILTERFLAGS EQU	160	;4x LP od HP
SAMPLENAME_RESOFILTERNUMB EQU	161	;Anzahl Punkte
SAMPLENAME_RESOFILTER	EQU	162	;bis 170

SAMPLENAME_VFADESTATUS	EQU	170
SAMPLENAME_VFADEBGN	EQU	SAMPLENAME_VFADESTATUS+1
SAMPLENAME_VFADEEND	EQU	SAMPLENAME_VFADEBGN+1 
 */
